"""init

Revision ID: 94310834c62d
Revises: 
Create Date: 2022-11-21 15:14:12.535332

"""
import sqlalchemy_utils
from alembic import op
import sqlalchemy as sa
import ryax.studio.infrastructure.database.utils


# revision identifiers, used by Alembic.
from ryax.studio.domain.workflow.workflow_values import WorkflowErrorCode

revision = '94310834c62d'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('action_category',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('logo',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('action_id', sa.String(), nullable=False),
    sa.Column('extension', sa.String(), nullable=False),
    sa.Column('content', sa.LargeBinary(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('description', sa.String(), nullable=True),
    sa.Column('validity_status', sa.Enum('valid', 'invalid', name='validity status'), nullable=True),
    sa.Column('deployment_status', sa.Enum('None', 'Deploying', 'Deployed', 'Undeploying', 'Error', name='deployment status'), nullable=True),
    sa.Column('deployment_error', sa.String(), nullable=True),
    sa.Column('owner', sa.String(), nullable=False),
    sa.Column('project', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_file',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('extension', sa.String(), nullable=False),
    sa.Column('path', sa.String(), nullable=False),
    sa.Column('size', sa.Float(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=False),
    sa.Column('version', sa.String(), nullable=False),
    sa.Column('kind', sa.Enum('Source', 'Processor', 'Publisher', name='action_kind'), nullable=False),
    sa.Column('description', sa.String(), nullable=True),
    sa.Column('has_dynamic_outputs', sa.Boolean(), nullable=False),
    sa.Column('logo_id', sa.String(), nullable=True),
    sa.Column('build_date', sa.DateTime(), nullable=False),
    sa.Column('project', sa.String(), nullable=False),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.ForeignKeyConstraint(['logo_id'], ['logo.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=False),
    sa.Column('version', sa.String(), nullable=False),
    sa.Column('description', sa.String(), nullable=True),
    sa.Column('kind', sa.Enum('Source', 'Processor', 'Publisher', name='action_kind'), nullable=False),
    sa.Column('has_dynamic_outputs', sa.Boolean(), nullable=False),
    sa.Column('custom_name', sa.String(), nullable=True),
    sa.Column('position_x', sa.Integer(), nullable=True),
    sa.Column('position_y', sa.Integer(), nullable=True),
    sa.Column('validity_status', sa.Enum('valid', 'invalid', name='validity status'), nullable=True),
    sa.Column('deployment_status', sa.Enum('None', 'Deploying', 'Deployed', 'Undeploying', 'Error', name='deployment status'), nullable=True),
    sa.Column('workflow_id', sa.String(), nullable=False),
    sa.Column('action_id', sa.String(), nullable=False),
    sa.Column('position', sa.Integer(), nullable=True),
    sa.Column('endpoint', sa.String(), nullable=True),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_id'], ['workflow.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_categories_association',
    sa.Column('action_category_id', sa.String(), nullable=True),
    sa.Column('action_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['action_category_id'], ['action_category.id'], ),
    sa.ForeignKeyConstraint(['action_id'], ['action.id'], )
    )
    op.create_table('action_io',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('display_name', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=True),
    sa.Column('help', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('string', 'longstring', 'integer', 'float', 'password', 'enum', 'file', 'directory', 'table', 'boolean', 'bytes', name='action_io_type'), nullable=False),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=False),
    sa.Column('input_of_action_id', sa.String(), nullable=True),
    sa.Column('output_of_action_id', sa.String(), nullable=True),
    sa.Column('default_value', sa.PickleType(), nullable=True),
    sa.ForeignKeyConstraint(['input_of_action_id'], ['action.id'], ),
    sa.ForeignKeyConstraint(['output_of_action_id'], ['action.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_category',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_output',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=True),
    sa.Column('display_name', sa.String(), nullable=True),
    sa.Column('help', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('string', 'longstring', 'integer', 'float', 'password', 'enum', 'file', 'directory', 'table', 'boolean', 'bytes', name='action_io_type'), nullable=True),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('is_dynamic', sa.Boolean(), nullable=False),
    sa.Column('origin', sa.Enum('path', 'header', 'query', 'cookie', 'body', name='dynamic_output_origin'), nullable=True),
    sa.Column('position', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_error',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('code', ryax.studio.infrastructure.database.utils.IntEnumType(WorkflowErrorCode), nullable=False),
    sa.Column('message', sa.String(), nullable=True),
    sa.Column('workflow_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_id'], ['workflow.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_link',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('upstream_action_id', sa.String(), nullable=False),
    sa.Column('downstream_action_id', sa.String(), nullable=False),
    sa.Column('workflow_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['downstream_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['upstream_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_id'], ['workflow.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_addons_input',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=True),
    sa.Column('display_name', sa.String(), nullable=True),
    sa.Column('help', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('string', 'longstring', 'integer', 'float', 'password', 'enum', 'file', 'directory', 'table', 'boolean', 'bytes', name='action_io_type'), nullable=True),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=True),
    sa.Column('static_value', sa.PickleType(), nullable=True),
    sa.Column('workflow_action_output_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('workflow_file_id', sa.String(), nullable=True),
    sa.Column('position', sa.Integer(), nullable=True),
    sa.Column('addon_name', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_action_output_id'], ['workflow_action_output.id'], ondelete='SET NULL'),
    sa.ForeignKeyConstraint(['workflow_file_id'], ['workflow_file.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_input',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=True),
    sa.Column('display_name', sa.String(), nullable=True),
    sa.Column('help', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('string', 'longstring', 'integer', 'float', 'password', 'enum', 'file', 'directory', 'table', 'boolean', 'bytes', name='action_io_type'), nullable=True),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=True),
    sa.Column('static_value', sa.PickleType(), nullable=True),
    sa.Column('workflow_action_output_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('workflow_file_id', sa.String(), nullable=True),
    sa.Column('position', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_action_output_id'], ['workflow_action_output.id'], ondelete='SET NULL'),
    sa.ForeignKeyConstraint(['workflow_file_id'], ['workflow_file.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_result',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('workflow_action_input_id', sa.String(), nullable=True),
    sa.Column('workflow_action_output_id', sa.String(), nullable=True),
    sa.Column('workflow_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['workflow_action_input_id'], ['workflow_action_input.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_action_output_id'], ['workflow_action_output.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_id'], ['workflow.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('workflow_result')
    op.drop_table('workflow_action_input')
    op.drop_table('workflow_action_addons_input')
    op.drop_table('workflow_link')
    op.drop_table('workflow_error')
    op.drop_table('workflow_action_output')
    op.drop_table('workflow_action_category')
    op.drop_table('action_io')
    op.drop_table('action_categories_association')
    op.drop_table('workflow_action')
    op.drop_table('action')
    op.drop_table('workflow_file')
    op.drop_table('workflow')
    op.drop_table('logo')
    op.drop_table('action_category')
    # ### end Alembic commands ###
